--[[*******************************************************************
	Variable Declaration
*******************************************************************]]
PMSearchFrame = 0;
local PMSearching = 0;
PriceMaster_English = nil;
local PMTextCollect = 0;
local PMRegion = GetLocale();
local OrderedItemLinks;
if PMRegion == "enUS" or PMRegion == "enGB" then
	PriceMaster_English = 1;
	PMPRICE_NOT_KNOWN = "The price is not known.";
	PMNO_SELL_PRICE = "No sell price";
	PMONE_SELLS_FOR = "One sells for:";
	PMSTACK_SELLS_FOR = "The stack sells for:"
elseif PMRegion == "frFR" then
	PMPRICE_NOT_KNOWN = "Le prix n'est pas connu.";
	PMNO_SELL_PRICE = "Aucun prix de vente";
	PMONE_SELLS_FOR = "On se vend pour:";
	PMSTACK_SELLS_FOR = "les ventes de pile pour :"
	elseif PMRegion == "deDE" then
	PMPRICE_NOT_KNOWN = "Unbekannter Preis.";
	PMNO_SELL_PRICE = "Kein Verkaufspreis";
	PMONE_SELLS_FOR = "Preis pro St\195\188ck:";
	PMSTACK_SELLS_FOR = "Gesamtpreis:"
elseif PMRegion == "koKR" then
	PMPRICE_NOT_KNOWN = "??? ??? ?? ???.";
	PMNO_SELL_PRICE = "?? ?? ??";
	PMONE_SELLS_FOR = "????? ?? ????:";
	PMSTACK_SELLS_FOR = "???? ?? ????:"
elseif PMRegion == "zhCN" then
	PMPRICE_NOT_KNOWN = "??????????";
	PMNO_SELL_PRICE = "??????";
	PMONE_SELLS_FOR = "???:";
	PMSTACK_SELLS_FOR = "????:"
elseif PMRegion == "zhTW" then
	PMPRICE_NOT_KNOWN = "??????????";
	PMNO_SELL_PRICE = "??????";
	PMONE_SELLS_FOR = "???:";
	PMSTACK_SELLS_FOR = "????:"
elseif PMRegion == "ruRU" then
	PMPRICE_NOT_KNOWN = "???? ?? ????????.";
	PMNO_SELL_PRICE = "??? ?? ???????? ????";
	PMONE_SELLS_FOR = "?????? ??????? ??:";
	PMSTACK_SELLS_FOR = "?????????????? ????? ???:"
else
	PMPRICE_NOT_KNOWN = "The price is not known.";
	PMNO_SELL_PRICE = "No sell price";
	PMONE_SELLS_FOR = "One sells for:";
	PMSTACK_SELLS_FOR = "The stack sells for:"
end
PMRegion = nil;
local Original_SetTooltipMoney;
local Original_SetItemRef;
local Original_InspectUnit;

-- Tooltip Display Functions
local Original_SetAuctionItem;
local Original_SetInventoryItem;
local Original_SetBagItem;
local Original_SetQuestItem;
local Original_SetLootItem;
local Original_SetQuestLogItem;
local Original_SetQuestLogItem;
local Original_SetCraftItem;
local Original_SetTradeSkillItem;
local Original_SetMerchantItem;
local Original_SetTradePlayerItem;
local Original_SetTradeTargetItem;
local Original_SetLootRollItem;
local Original_GuildPromote;


-- Compression variables

local FullServerList = {
	["Agamaggan"] = 6,
	["Aggramar"] = 7,
	["Akama"] = 8,
	["Alexstrasza"] = 9,
	["Alleria"] = 10,
	["Archimonde"] = 11,
	["Argent Dawn"] = 12,
	["Arthas"] = 13,
	["Azgalor"] = 14,
	["Azjol-Nerub"] = 15,
	["Azshara"] = 16,
	["Balnazzar"] = 17,
	["Blackhand"] = 18,
	["Blackrock"] = 19,
	["Bleeding Hol"] = 20,
	["Bloodhoof"] = 21,
	["Bloodscalp"] = 22,
	["Bonechewer"] = 23,
	["Boulderfist"] = 24,
	["Bronzebeard"] = 25,
	["Burning Blade"] = 26,
	["Burning Legion"] = 27,
	["Cenarion Circle"] = 28,
	["Cenarius"] = 29,
	["Cho'gall"] = 30,
	["Chromaggus"] = 31,
	["Crushridge"] = 32,
	["Daggerspine"] = 33,
	["Dalaran"] = 34,
	["Dark Iron"] = 35,
	["Darkspear"] = 36,
	["Deathwing"] = 37,
	["Destromath"] = 38,
	["Dethecus"] = 39,
	["Detheroc"] = 40,
	["Doomhammer"] = 41,
	["Draenor"] = 42,
	["Dragonblight"] = 43,
	["Dragonmaw"] = 44,
	["Drak'thul"] = 45,
	["Draka"] = 46,
	["Dunemaul"] = 47,
	["Durotan"] = 48,
	["Earthen Ring"] = 49,
	["Eldre'Thalas"] = 50,
	["Elune"] = 51,
	["Emerald Dream"] = 52,
	["Eonar"] = 53,
	["Eredar"] = 54,
	["Feathermoon"] = 55,
	["Firetree"] = 56,
	["Frostmane"] = 57,
	["Frostmourne"] = 58,
	["Frostwolf"] = 59,
	["Garona"] = 60,
	["Gilneas"] = 61,
	["Gorefiend"] = 62,
	["Gorgonnash"] = 63,
	["Greymane"] = 64,
	["Gul'dan"] = 65,
	["Gurubashi"] = 66,
	["Hakkar"] = 67,
	["Hellscream"] = 68,
	["Hyjal"] = 69,
	["Icecrown"] = 70,
	["Illidan"] = 71,
	["Kael'thas"] = 72,
	["Kalecgos"] = 73,
	["Kargath"] = 74,
	["Kel'Thuzad"] = 75,
	["Khadgar"] = 76,
	["Khaz'goroth"] = 77,
	["Kil'Jaeden"] = 78,
	["Kilrogg"] = 79,
	["Kirin Tor"] = 80,
	["Laughing Skull"] = 81,
	["Lightbringer"] = 82,
	["Lightning's Blade"] = 83,
	["Lightninghoof"] = 84,
	["Llane"] = 85,
	["Lothar"] = 86,
	["Maelstorm"] = 87,
	["Magtheridon"] = 88,
	["Mal'Ganis"] = 89,
	["Malfurion"] = 90,
	["Malygos"] = 91,
	["Mannoroth"] = 92,
	["Medivh"] = 93,
	["Moonrunner"] = 94,
	["Nathrezim"] = 95,
	["Ner'zhul"] = 96,
	["Perenolde"] = 97,
	["Proudmoore"] = 98,
	["Sargeras"] = 99,
	["Scarlet Crusade"] = 100,
	["Sen'Jin"] = 101,
	["Shadow Council"] = 102,
	["Shadow Moon"] = 103,
	["Shadowsong"] = 104,
	["Shattered Hand"] = 105,
	["Silver Hand"] = 106,
	["Silvermoon"] = 107,
	["Skullcrusher"] = 108,
	["Skywall"] = 109,
	["Smolderthorn"] = 110,
	["Spinebreaker"] = 111,
	["Spirestone"] = 112,
	["Staghelm"] = 113,
	["Stonemaul"] = 114,
	["Stormrage"] = 115,
	["Stormreaver"] = 116,
	["Stormscale"] = 117,
	["Suramar"] = 118,
	["Terenas"] = 119,
	["Thunderhorn"] = 120,
	["Thunderlord"] = 121,
	["Tichondrius"] = 122,
	["Twisting Nether"] = 123,
	["Uldum"] = 124,
	["Ursin"] = 125,
	["Uther"] = 126,
	["Vek'nilash"] = 127,
	["Warsong"] = 128,
	["Whisperwind"] = 129,
	["WildHammer"] = 130,
	["Windrunner"] = 131,
	["Zul'jin"] = 132,
	["Khaz Modan"] = 133,
	["Garithos"] = 134,
	["Nordrassil"] = 135,
	["Runetotem"] = 136,
	["Arathor"] = 137,
	["Madmortem"] = 138,
	["Moonglade"] = 139,
	["Rexxar"] = 140,
	["Frostwhisper"] = 141,
	["Thorium Brotherhood"] = 142,
	["Bladefist"] = 143,
	["Zangarmarsh"] = 144,
	["Executus"] = 145,
	["Area 52"] = 146,
};
local SuffixList = {
	--stats
	" of Agility",
	" of Intellect",
	" of Spirit",
	" of Stamina",
	" of Strength", 			--5
	--animals
	" of the Falcon",
	" of the Wolf",
	" of the Monkey",
	" of the Tiger",
	" of the Owl", 			--10
	" of the Eagle",
	" of the Gorilla",
	" of the Whale",
	" of the Boar",	
	" of the Bear", 			--15
	--resistances
	" of Arcane Resistance",
	" of Frost Resistance",
	" of Fire Resistance",
	" of Shadow Resistance",
	" of Nature Resistance",	--20
	-- Skills
	" of Power",
	" of Defense",
	" of Blocking",
	" of Marksmanship",
	" of Eluding", 			--25
	--wrath
	" of Arcane Wrath",
	" of Shadow Wrath",
	" of Fiery Wrath",
	" of Holy Wrath",
	" of Frozen Wrath", 		--30
	" of Nature's Wrath",
	--Spell Buffs
	" of Healing",
	" of Concentration",
	" of Regeneration",
	" of Sorcery",  			--35
	" of Restoration",
	" of Striking",
	--TBC
	" of the Elder",
	" of the Hierophant",
	" of the Sorcerer", 		--40
	" of the Physician",
	" of the Prophet",
	" of the Invoker",
	" of the Mind",
	" of the Crusade", 		--45
	" of the Vision",
	" of the Nightmare",
	" of the Bandit",
	" of the Beast",
	" of the Soldier", 		--50
	" of the Champion",
	" of Blocking",
	" of the Grove",
	" of the Hunt",
	" of the Ancestor", 		--55
	" of the Battle",
	" of the Shadow",
	--Resistances
	" of Shadow Protection",
	" of Fire Protection",
	" of Arcane Protection",	--60
	" of Frost Protection",		
	" of Nature Protection",
};
local PriceMaster_Temp = {};
local PriceMaster_Realm = GetRealmName()
if FullServerList[GetRealmName()] then
	PriceMaster_Realm = FullServerList[GetRealmName()];
end
local PriceMaster_AtMerchant;
CompletePrices = {};
UIPanelWindows["PriceMaster_Window"] = { area = "left", pushable = 9, whileDead = 1 };
--[[*******************************************************************
	Debug Functions
*******************************************************************]]
local function PriceMaster_Chat(str)
	if ( DEFAULT_CHAT_FRAME ) then 
		DEFAULT_CHAT_FRAME:AddMessage(str, 1.0, 0.5, 0.25);
	end
end
--[[*******************************************************************
	Conversion Functions (Old to new color, string to price, etc...)
*******************************************************************]]
local function PriceMaster_GetPriceMasterColorFromHex(hex)
	if ( hex == "ff9d9d9d") then
		return 0; -- Grey
	elseif ( hex == "ffffffff" ) then
		return 1; -- White
	elseif	 ( hex == "ff1eff00" ) then
		return 2; -- Green
	elseif	 ( hex == "ff0070dd" ) then
		return 3; -- Blue
	elseif	 ( hex == "ffa335ee" ) then
		return 4; -- Purple
	elseif	 ( hex == "ffff8000" ) then
		return 5; -- Orange
	elseif   ( hex == "ffe6cc80") then
		return 6; -- Gold
	end
end
local function PriceMaster_GetSuffix(vid) -- If ANYBODY who is readidng this code feels up to it and optimize. Please.
	vid = vid + 0;
	if vid == 0 then
		return "";
	elseif vid == -8 or (vid >= 1009 and vid <= 1093) then
		return(SuffixList[13]);
	elseif vid == -6 or (vid >= 839 and vid <= 923) then
		return(SuffixList[11]);
	elseif vid == -9 or (vid >= 754 and vid <= 839) then
		return(SuffixList[10]);
	elseif vid == -7 or (vid >= 1179 and vid <= 1263) then
		return(SuffixList[15]);
	elseif (vid >= -5 and vid <= 4) or (vid >= 584 and vid <= 668) then
		return(SuffixList[8]);
	elseif vid == -16 or vid == 15 or (vid >= 19 and vid <= 22) or vid == 96 or vid == 114 or vid == 135 or vid == 154 or (vid >= 184 and vid <= 188) or (vid >= 217 and vid <= 218) or (vid >= 287 and vid <= 306) or (vid >= 333 and vid <= 357) then
		return(SuffixList[4]);
	elseif vid == -12 or (vid >= 1094 and vid <= 1178) then
		return(SuffixList[14]);
	elseif vid == -14 or (vid >= 669 and vid <= 754) then
		return(SuffixList[9]);
	elseif vid == -13 or vid == 228 or (vid >= 256 and vid <= 266) or (vid >= 501 and vid <= 584) then
		return(SuffixList[7]);
	elseif vid == -15 or vid == 16 or (vid >= 27 and vid <= 47) or vid == 95 or vid == 113 or vid == 134 or vid == 153 or (vid >= 179 and vid <= 184) or (vid >= 215 and vid <= 217) or (vid >= 409 and vid <= 423) then
		return(SuffixList[3]);
	elseif vid == -11 or vid == 227 or (vid >= 229 and vid <= 256) or (vid >= 423 and vid <= 501) then
		return(SuffixList[6]);
	elseif vid == -19 or vid == 5 or (vid >= 25 and vid <= 27) or vid == 94 or vid == 112 or vid == 133 or vid == 152 or (vid >= 174 and vid <= 179) or (vid >= 213 and vid <= 215) or (vid >= 383 and vid <= 409) then
		return(SuffixList[2]);
	elseif vid == -10 or (vid >= 924 and vid <= 1009) then
		return(SuffixList[12]);
	elseif vid == -20 or (vid >= 1547 and vid <= 1606) then
		return(SuffixList[21]);
	elseif vid == -17 or vid == -62 or (vid >= 6 and vid <= 13) or (vid >= 23 and vid <= 25) or (vid >= 97 and vid <= 107) or (vid >= 115 and vid <= 127) or (vid >= 136 and vid <= 146) or (vid >= 155 and vid <= 166) or (vid >= 189 and vid <= 210) or (vid >= 219 and vid <= 227) or (vid >= 307 and vid <= 333) then
		return(SuffixList[5]);
	elseif vid == -18 or vid == -63 or vid == 14 or (vid >= 17 and vid <= 19) or vid == 93 or vid == 111 or vid == 132 or vid == 151 or (vid >= 167 and vid <= 174) or (vid >= 211 and vid <= 213) or (vid >= 267 and vid <= 287) or (vid >= 358 and vid <= 383) then
		return(SuffixList[1]);
	elseif vid == -26 or vid == -61 or(vid >= 2027 and vid <= 2068) then
		return(SuffixList[32]);
	elseif vid == -21 or (vid >= 1799 and vid <= 1836) then
		return(SuffixList[26]);
	elseif vid == -27 or (vid >= 48 and vid <= 93) or (vid >= 108 and vid <= 111) or (vid >= 128 and vid <= 132) or (vid >= 147 and vid <= 151) or (vid >= 1607 and vid <= 1646) then
		return(SuffixList[22]);
	elseif vid == -22 or (vid >= 1875 and vid <= 1912) then
		return(SuffixList[28]);
	elseif vid == -23 or (vid >= 1951 and vid <= 1988) then
		return(SuffixList[30]);
	elseif vid == -25 or (vid >= 1837 and vid <= 1875) then
		return(SuffixList[27]);
	elseif vid == -24 or (vid >= 1989 and vid <= 2027) then
		return(SuffixList[31]);
	elseif (vid >= 1402 and vid <= 1447) then
		return(SuffixList[18]);
	elseif (vid >= 1356 and vid <= 1402) then
		return(SuffixList[17]);
	elseif (vid >= 1494 and vid <= 1547) then
		return(SuffixList[20]);
	elseif (vid >= 1448 and vid <= 1494) then
		return(SuffixList[19]);
	elseif (vid >= 1310 and vid <= 1356) then
		return(SuffixList[16]);
	elseif vid == -28 or (vid >= 2108 and vid <= 2142) then
		return(SuffixList[34]);
	elseif vid == -29 or (vid >= 1748 and vid <= 1799) then
		return(SuffixList[25]);
	elseif vid == -47 or (vid >= 1647 and vid <= 1707) then
		return(SuffixList[23]);
	elseif (vid >= 2146 and vid <= 2148) or vid == 2153 or vid == 2156 or vid == 2162 then
		return(SuffixList[36]);
	elseif vid == -30 or (vid >= 2069 and vid <= 2108) then
		return(SuffixList[33]);
	elseif (vid >= 2149 and vid <= 2151) or vid == 2154 or (vid >= 2157 and vid <= 2162) or (vid >= 2163 and vid <= 3051) then
		return(SuffixList[37]);
	elseif (vid >= 2143 and vid <= 2146) or vid == 2152 or vid == 2155 then
		return(SuffixList[35]);
	elseif vid == -57 then
		return(SuffixList[57]);
	elseif vid == -56 then
		return(SuffixList[56]);
	elseif vid == -55 then
		return(SuffixList[47]);
	elseif vid == -54 then
		return(SuffixList[55]);
	elseif vid == -53 then
		return(SuffixList[46]);
	elseif vid == -52 then
		return(SuffixList[45]);
	elseif vid == -51 then
		return(SuffixList[44]);
	elseif vid == -50 then
		return(SuffixList[54]);
	elseif vid == -45 then
		return(SuffixList[51]);
	elseif vid == -44 then
		return(SuffixList[38]);
	elseif vid == -43 then
		return(SuffixList[50]);
	elseif vid == -42 then
		return(SuffixList[39]);
	elseif vid == -41 then
		return(SuffixList[49]);
	elseif vid == -40 then
		return(SuffixList[48]);
	elseif vid == -39 then
		return(SuffixList[43]);
	elseif vid == -38 then
		return(SuffixList[42]);
	elseif vid == -37 then
		return(SuffixList[41]);
	elseif vid == -36 then
		return(SuffixList[40]);
	elseif vid == -35 then
		return(SuffixList[58]);
	elseif vid == -34 then
		return(SuffixList[62]);
	elseif vid == -33 then
		return(SuffixList[61]);
	elseif vid == -32 then
		return(SuffixList[59]);
	elseif vid == -31 then
		return(SuffixList[60]);
	elseif (vid >= 1708 and vid <= 1748) then
		return(SuffixList[24]);
	elseif (vid >= 1913 and vid <= 1951) then
		return(SuffixList[29]);
	elseif (vid >= -49 and vid <= -46) then
		return(SuffixList[53]);
	end
	return nil;
end
local function PriceMaster_TextFromPrice(price)	-- Converts a price number to a string for display in ItemRef
	local gold, silver, copper;
	local moneytext = "";
	if ( price < 100 ) then
		copper = price + 0;
	else
		gold = math.floor(price / 10000);
		silver = math.floor((price - ( 10000 * gold ) ) / 100 )
		copper = price - (( 10000 * gold ) + ( silver * 100))
	end
	if ( gold and gold ~= 0 ) then
		moneytext = moneytext .. " |cffffd100" .. gold .. "g|r";
	end
	if ( silver and silver ~= 0 ) then
		moneytext = moneytext .. " |cffe6e6e6" .. silver .. "s|r";
	end
	if ( copper and copper ~= 0 ) then
		moneytext = moneytext .. " |cffc8602c" .. copper .. "c|r";
	end
	return( moneytext );
end
local function PriceMaster_PriceText(price)	-- Converts a price number to a string for display in whispers
	local gold, silver, copper;
	local moneytext = "";
	if ( price < 100 ) then
		copper = price + 0;
	else
		gold = math.floor(price / 10000);
		silver = math.floor((price - ( 10000 * gold ) ) / 100 )
		copper = price - (( 10000 * gold ) + ( silver * 100))
	end
	if ( gold and gold ~= 0 ) then
		moneytext = moneytext .. " "..gold .. "g";
	end
	if ( silver and silver ~= 0 ) then
		moneytext = moneytext .. " ".. silver .. "s";
	end
	if ( copper and copper ~= 0 ) then
		moneytext = moneytext .. " "..copper .. "c";
	end
	return( moneytext );
end
--[[*******************************************************************
	Data Collection Functions
*******************************************************************]]
local function PriceMaster_GetType(ty, st)
	if st == "Cloth" then return 0, 0; 
	elseif st == "Idols" then return 0, 1;
	elseif st == "Leather" then return 0, 2; 
	elseif st == "Librams" then return 0, 3; 
	elseif st == "Mail" then return 0, 4; 
	elseif st == "Miscellaneous" then return 0, 5; 
	elseif st == "Shields" then return 0, 6; 
	elseif st == "Totems" then return 0, 7; 
	elseif st == "Plate" then return 0, 8;
	elseif st == "Consumable" then return 1,0;
	elseif st == "Bag" then return 2,0;
	elseif st == "Enchanting Bag" then return 2,1;
	elseif st == "Engineering Bag"  then return 2,2;
	elseif st == "Herb Bag" then return 2,3;
	elseif st == "Soul Bag" then return 2,4;
	elseif st == "Key" then return 3,0;
	elseif st == "Junk" then return 4,0;
	elseif st == "Reagent" then return 5,0;
	elseif st == "Alchemy" then return 6,0;
	elseif st == "Blacksmithing" then return 6,1;
	elseif st == "Book" then return 6,2;
	elseif st == "Cooking" then return 6,3;
	elseif st == "Enchanting" then return 6,4;
	elseif st == "Engineering" then return 6,5;
	elseif st == "First Aid" then return 6,6;
	elseif st == "Leatherworking" then return 6,7;
	elseif st == "Tailoring" then return 6,8;
	elseif st == "Arrow" then return 7,0;
	elseif st == "Bullet" then return 7,1;
	elseif st == "Quest" then return 8,0;
	elseif st == "Ammo Pouch" then return 9,0;
	elseif st == "Quiver" then return 9,1;
	elseif st == "Devices" then return 10,0;
	elseif st == "Explosives" then return 10,1;
	elseif st == "Parts" then return 10,2;
	elseif st == "Trade Goods" then return 10,3;
	elseif st == "Bows" then return 11,0;
	elseif st == "Crossbows" then return 11,1;
	elseif st == "Daggers" then return 11,2;
	elseif st == "Guns" then return 11,3;
	elseif st == "Fishing Pole" then return 11,4;
	elseif st == "Fist Weapons" then return 11,5;
	elseif st == "Miscellaneous" then return 11,6;
	elseif st == "One-Handed Axes" then return 11,7;
	elseif st == "One-Handed Maces" then return 11,8;
	elseif st == "One-Handed Swords" then return 11,9;
	elseif st == "Polearms" then return 11,10;
	elseif st == "Staves" then return 11,11;
	elseif st == "Thrown" then return 11,12;
	elseif st == "Two-Handed Axes" then return 11,13;
	elseif st == "Two-Handed Maces" then return 11,14;
	elseif st == "Two-Handed Swords" then return 11,15;
	elseif st == "Wands" then return 11,16;
	else return nil; end		
end
local function PriceMaster_GetLoc(l)
	if l == "" then return nil;
	elseif l == "INVTYPE_AMMO" then return 0;
	elseif l == "INVTYPE_HEAD" then return 1;
	elseif l == "INVTYPE_NECK" then return 2;
	elseif l == "INVTYPE_SHOULDER" then return 3;
	elseif l == "INVTYPE_BODY" then return 4;
	elseif l == "INVTYPE_CHEST" then return 5;
	elseif l == "INVTYPE_ROBE" then return 6;
	elseif l == "INVTYPE_WAIST" then return 7;
	elseif l == "INVTYPE_LEGS" then return 8;
	elseif l == "INVTYPE_FEET" then return 9;
	elseif l == "INVTYPE_WRIST" then return 10;
	elseif l == "INVTYPE_HAND" then return 11;
	elseif l == "INVTYPE_FINGER" then return 12;
	elseif l == "INVTYPE_TRINKET" then return 13;
	elseif l == "INVTYPE_CLOAK" then return 14;
	elseif l == "INVTYPE_WEAPON" then return 15;
	elseif l == "INVTYPE_SHIELD" then return 16;
	elseif l == "INVTYPE_2HWEAPON" then return 17;
	elseif l == "INVTYPE_WEAPONMAINHAND" then return 18;
	elseif l == "INVTYPE_WEAPONOFFHAND" then return 19;
	elseif l == "INVTYPE_HOLDABLE" then return 20;
	elseif l == "INVTYPE_RANGED" then return 21;
	elseif l == "INVTYPE_THROWN" then return 22;
	elseif l == "INVTYPE_RANGEDRIGHT" then return 23;
	elseif l == "INVTYPE_RELIC" then return 24;
	elseif l == "INVTYPE_TABARD" then return 25;
	elseif l == "INVTYPE_BAG" then return 26;
	else return nil; end
end
local function PriceMaster_ProcessLinks(text, simple) -- Adds the link (not price) to the database. This includes color, name, and all that good stuff
	local color, iid, vid, name;					  -- Set simple to true if color and name should be ignored (I.E. Could feasably be falsified)
	if( text ) then
		local _, _, color, iid, vid, name = string.find(text, "|c(%x+)|Hitem:(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+|h%[(.-)%]|h|r");		
		if( color and iid and vid and name and name ~= "" ) then
			iid = iid + 0;
			vid = vid + 0;
			color = PriceMaster_GetPriceMasterColorFromHex(color);
			if (not simple or simple ~= true ) then
				if not LocalPrices[iid] then
					LocalPrices[iid] = {};
				end
				if not LocalPrices[iid] then
					LocalPrices[iid] = {};
				end
				if not LocalPrices[iid]["v"] then
					LocalPrices[iid]["v"] = {};
				end
				if not LocalPrices[iid]["v"][vid] then
					LocalPrices[iid]["v"][vid] = {};
				end
				LocalPrices[iid]["v"][vid][PriceMaster_Realm] = 2;
				if not CompletePrices[iid] then
					CompletePrices[iid] = {};
				end
				if not CompletePrices[iid] then
					CompletePrices[iid] = {};
				end
				if not CompletePrices[iid]["v"] then
					CompletePrices[iid]["v"] = {};
				end
				if not CompletePrices[iid]["v"][vid] then
					CompletePrices[iid]["v"][vid] = {};
				end
				CompletePrices[iid]["v"][vid][PriceMaster_Realm] = 2;
			end
			if not CompletePrices[iid] then
				CompletePrices[iid] = {};
			end
			if ( not CompletePrices[iid].c or CompletePrices[iid].c ~= color) then
				CompletePrices[iid].c = color;
				if not LocalPrices[iid] then
					LocalPrices[iid] = {};
				end
				LocalPrices[iid].c = color;
			end
			if PriceMaster_English then
				if not CompletePrices[iid]["v"] then
					CompletePrices[iid]["v"] = {}
				end
				if ( not CompletePrices[iid]["v"][vid] ) then
					CompletePrices[iid]["v"][vid] = {};
					if not LocalPrices[iid] then
						LocalPrices[iid] = {};
					end
					if not LocalPrices[iid].v then
						LocalPrices[iid].v = {};
					end
					if not LocalPrices[iid]["v"][vid] then
						LocalPrices[iid]["v"][vid] = {};
					end
				end
				if (not simple or simple ~= true) and CompletePrices[iid]["v"] and CompletePrices[iid]["v"][vid] and CompletePrices[iid]["v"][vid][PriceMaster_Realm] and CompletePrices[iid]["v"][vid][PriceMaster_Realm] == 1 then
					CompletePrices[iid]["v"][vid][PriceMaster_Realm] = nil;
					if not LocalPrices[iid] then
						LocalPrices[iid] = {};
					end
					if not LocalPrices[iid].v then
						LocalPrices[iid].v = {};
					end
					if not LocalPrices[iid]["v"][vid] then
						LocalPrices[iid]["v"][vid] = {};
					end
					LocalPrices[iid]["v"][vid][PriceMaster_Realm] = 0;
				end
				local suffix = PriceMaster_GetSuffix(vid);
				if not LocalPrices[iid] then
					LocalPrices[iid] = {};
				end
				if CompletePrices[iid]["v"][vid]["x"] then
					suffix = SuffixList[CompletePrices[iid]["v"][vid]["x"]];
				end
				if not CompletePrices[iid].n then
					CompletePrices[iid].n = "";
				end
				if vid ~= 0 and (not suffix or CompletePrices[iid].n .. suffix ~= name) then
					local tmp = 0;
					for i, testsuffix in pairs(SuffixList) do
						if tmp == 0 and string.find(name, testsuffix) then
							tmp = 1;
							suffixstart, suffixend = string.find(name, testsuffix);
							if suffixend == string.len(name) then
								if CompletePrices[iid].n ~= string.sub(name, 1, suffixstart - 1) then
									CompletePrices[iid].n = string.sub(name, 1, suffixstart - 1);
									if not LocalPrices[iid] then
										LocalPrices[iid] = {};
									end
									LocalPrices[iid].n = string.sub(name, 1, suffixstart - 1);
								end
								if not CompletePrices[iid]["v"][vid]["x"] or CompletePrices[iid]["v"][vid]["x"] ~= i then
									CompletePrices[iid]["v"][vid]["x"] = i;
									if not LocalPrices[iid] then
										LocalPrices[iid] = {};
									end
									if not LocalPrices[iid].v then
										LocalPrices[iid].v = {};
									end
									if not LocalPrices[iid]["v"][vid] then
										LocalPrices[iid]["v"][vid] = {};
									end
									LocalPrices[iid]["v"][vid]["x"] = i;
								end
							end
						end
					end
					if tmp == 0 and (not CompletePrices[iid].n or CompletePrices[iid].n ~= name) then
						CompletePrices[iid].n = name;
						if not LocalPrices[iid] then
							LocalPrices[iid] = {};
						end
						LocalPrices[iid].n = name;
					end
				elseif suffix == "" or vid == 0 then
					if not CompletePrices[iid].n or CompletePrices[iid].n ~= name then
						CompletePrices[iid].n = name;
						if not LocalPrices[iid] then
							LocalPrices[iid] = {};
						end
						LocalPrices[iid].n = name;
					end
				end
			end
		else
			local _, _, iid, name = string.find(text, "|cffffd000|Henchant:(%d+)|h%[(.-)%]|h|r");
			if iid and name then
				iid = iid + 0;		
				if not CompletePrices[iid] then
					CompletePrices[iid] = {};
				end
				if not CompletePrices[iid].m or CompletePrices[iid].m ~= name then
					CompletePrices[iid].m = name;
					if not LocalPrices[iid] then
						LocalPrices[iid] = {};
					end
					LocalPrices[iid].m = name;
				end
			end
		end
	end
end
local function PriceMaster_SetPrice() -- Retrieves the price for an item (When at a merchant, and having money displayed)
	if ( PriceMaster_Temp.Count == 1 and PriceMaster_Temp.Repair ) then
		price = PriceMaster_Temp.Price + PriceMaster_Temp.Repair;
	else
		price = PriceMaster_Temp.Price / PriceMaster_Temp.Count;
	end
	for iid in string.gmatch(PriceMaster_Temp.link, "item:(%d+):") do
		iid = iid + 0;
		if not CompletePrices[iid] then
			PriceMaster_ProcessLinks(PriceMaster_Temp.link);
		end
		if ( math.floor(price) == price and ( not CompletePrices[iid].p or price ~= CompletePrices[iid].p )) then
			CompletePrices[iid].p = price;
			if ( not LocalPrices[iid] ) then
				LocalPrices[iid] = { };
			end
			LocalPrices[iid].p = price;
		end
	end
end
local function PriceMaster_ScanInventory() -- Goes through the player's entire inventory, and trys to add every link.
	local bagid;
	local size;
	local slotid;
	local link;	
	for bagid = 0, 4, 1 do
		size = GetContainerNumSlots(bagid);
		if( size ) then
			for slotid = size, 1, -1 do
				link = GetContainerItemLink(bagid, slotid);
				if( link ) then
					PriceMaster_ProcessLinks(link);
				end
			end
		end
	end
end
local function PriceMaster_ScanAuction()
	local AuctionsThisPage = GetNumAuctionItems("list");
	if (AuctionsThisPage > 0) then
		for ItemPlace = 1, AuctionsThisPage do
			local link = GetAuctionItemLink("list", ItemPlace);
			if( link ) then
				PriceMaster_ProcessLinks(link);
			end
		end
	end
end
--[[*******************************************************************
	Data Display Functions
*******************************************************************]]
function PriceMaster_DisplayTooltipMoney(money, iid, window, count) -- Displays money in GameTooltip
	local moneyFrame = getglobal(GameTooltip:GetName().."MoneyFrame");
	local numLines = GameTooltip:NumLines();
	local mytext = getglobal("GameTooltipTextLeft" .. numLines);
	if( money == "Unknown" ) then
		if ( PriceMaster_AtMerchant ) then
			if ( "No sell price" == mytext:GetText() ) then
				if ( not LocalPrices[iid] ) then
					LocalPrices[iid] = {};
				end
				if CompletePrices[iid].p ~= 0 then
					LocalPrices[iid].p = 0;
					CompletePrices[iid].p = 0;
				end
				return nil;
			end
		end
		GameTooltip:AddLine(PMPRICE_NOT_KNOWN);
		GameTooltip:SetHeight(GameTooltip:GetHeight() + 12);
		local numLines = GameTooltip:NumLines();
		local newLine = GameTooltip:GetName().."TextLeft"..numLines;
		
		if ( ( getglobal(newLine):GetWidth() + 20 ) > GameTooltip:GetWidth() ) then
			GameTooltip:SetWidth( getglobal(newLine):GetWidth() + 20);
		end
		return nil;
	elseif ( not moneyFrame:IsVisible() ) then
		if ( PriceMaster_AtMerchant and not PriceMaster_Window:IsVisible() ) then
			if ( "No sell price" == mytext:GetText() ) then
				if ( not LocalPrices[iid] ) then
					LocalPrices[iid] = {};
				end
				if CompletePrices[iid].p ~= 0 then
					LocalPrices[iid].p = 0;
					CompletePrices[iid].p = 0;
				end
				return nil;
			end
		end
		if ( window == true) then
			if ( money == 0 ) then
				GameTooltip:SetText(PMNO_SELL_PRICE, 1.0, 1.0, 1.0);
				
				local newLine = GameTooltip:GetName().."TextLeft1";
				if ( ( getglobal(newLine):GetWidth() + 20 ) > GameTooltip:GetWidth() ) then
					GameTooltip:SetWidth( getglobal(newLine):GetWidth() + 20);
				end
				return nil;
			else
				GameTooltip:SetText(PMONE_SELLS_FOR, 1.0, 1.0, 1.0);
			end
		elseif (mytext:GetText() ~= "No sell price") then
			if ( money == 0 ) then
				GameTooltip:AddLine(PMNO_SELL_PRICE, 1.0, 1.0, 1.0);
				GameTooltip:SetHeight(GameTooltip:GetHeight() + 12);
				local numLines = GameTooltip:NumLines();
				local newLine = GameTooltip:GetName().."TextLeft"..numLines;

				if ( ( getglobal(newLine):GetWidth() + 20 ) > GameTooltip:GetWidth() ) then
					GameTooltip:SetWidth( getglobal(newLine):GetWidth() + 20);
				end
				return nil;
			else
				if not count or not PMStack or count == 1 or count == 0 then
					GameTooltip:AddLine(PMONE_SELLS_FOR, 1.0, 1.0, 1.0);
					GameTooltip:SetHeight(GameTooltip:GetHeight() + 12);
				else
					GameTooltip:AddLine(PMSTACK_SELLS_FOR, 1.0, 1.0, 1.0);
					GameTooltip:SetHeight(GameTooltip:GetHeight() + 12);
					money = count * money;
				end
			end
		end
		local numLines = GameTooltip:NumLines();
		local newLine = GameTooltip:GetName().."TextLeft"..numLines;
		
		moneyFrame:SetPoint("LEFT", newLine, "LEFT", getglobal(newLine):GetWidth() + 4, 0);
		MoneyFrame_Update(moneyFrame:GetName(), money);
		if ( ( getglobal(newLine):GetWidth() + moneyFrame:GetWidth() + 15) > GameTooltip:GetWidth() ) then
			GameTooltip:SetWidth(moneyFrame:GetWidth() + getglobal(newLine):GetWidth() + 18);
		end
		moneyFrame:Show();
	end
end
local function PriceMaster_CheckTooltipInfo(link, count) -- Check to see if a tooltip needs money displayed
	if( GameTooltip:IsVisible() and link) then
		for iid in string.gmatch(link, "item:(%d+):") do
			iid = iid + 0;
			if( iid and CompletePrices[iid]) then
				if ( CompletePrices[iid].p ) then
					PriceMaster_DisplayTooltipMoney(CompletePrices[iid].p, iid, false, count);
				else
					PriceMaster_DisplayTooltipMoney("Unknown", iid, false);
				end
			end
		end
	end
end
--[[*******************************************************************
	ItemRef Functions (The popup window thing)
*******************************************************************]]
local function PriceMaster_SetItemRefMoney(link)
	local _, _, iid = string.find(link, "(%d+):%d+:%d+:%d+:%d+:%d+:%--%d+:%--%d+");
	if iid then
		iid = iid + 0;
		if ( CompletePrices[iid] ) then
			if ( not CompletePrices[iid].p ) then
				ItemRefTooltip:AddLine(PMPRICE_NOT_KNOWN);
			else
				if ( CompletePrices[iid].p == 0 ) then
					ItemRefTooltip:AddLine(PMNO_SELL_PRICE, 1.0, 1.0, 1.0);
				else
					ItemRefTooltip:AddLine(PMONE_SELLS_FOR .. PriceMaster_TextFromPrice(CompletePrices[iid].p), 1.0, 1.0, 1.0);
				end
			end
		else
			ItemRefTooltip:AddLine(PMPRICE_NOT_KNOWN, .4, .4, .4);
		end
		local numLines = ItemRefTooltip:NumLines();
		local newLine = ItemRefTooltip:GetName().."TextLeft"..numLines;
		local height = ItemRefTooltip:GetHeight();

		ItemRefTooltip:SetHeight(height + 12);

		if (( getglobal(newLine):GetWidth() + 20 ) > ItemRefTooltip:GetWidth() ) then
			ItemRefTooltip:SetWidth(getglobal(newLine):GetWidth() + 20);
		end
	end
end
--[[*******************************************************************
	PriceMaster Window Functions
*******************************************************************]]
function PriceMaster_Console() -- Show the PriceMaster window
	if ( PriceMaster_Window:IsVisible() or not PriceMaster_English) then
		HideUIPanel(PriceMaster_Window);
	else
		ShowUIPanel(PriceMaster_Window);
		PriceMaster_EditBox:SetText("");
		PriceMaster_OptionsFrame:Hide();
		PriceMaster_Search();
	end
end
function PriceMaster_Search(search) -- Descides wich items should be displayed based on an optional search
	local PMItemCount = 0;
	local PMOtherItemCount = 0;
	local LOrderedItemLinks = { };
	local OrangeItem = {};
	local GrayItem = {};
	local PurpleItem = {};
	local BlueItem = {};
	local GreenItem = {};
	local WhiteItem = {};
	local CraftedItem = {};
	local itemname;
	local link;
	local Recipies = { "Alchemy", "Blacksmithing", "Cooking", "Enchanting", "Enchant", "Engineering", "First Aid", "Jewelcrafting", "Leatherworking", "Mining", "Poison", "Tailoring"};
	local Counts = {};
	for i = 1, #Recipies, 1 do
		Counts[i] = 0;
	end
	for iid, val in pairs(CompletePrices) do
		if val.n and val.v then
			for vid, realms in pairs(val.v) do 
				if vid >= 0 then
					if ( PMSearchFrame == 0 and ( not realms[PriceMaster_Realm] or realms[PriceMaster_Realm] ~= 1 )) or ( PMSearchFrame == realms[PriceMaster_Realm] ) then
						if realms.x then
							if SuffixList[realms.x] then
								itemname = val.n .. SuffixList[realms.x];
							else
								itemname = ( val.n .. realms.x)
							end
						else 
							if PriceMaster_GetSuffix(vid) then
								itemname = ( val.n .. PriceMaster_GetSuffix(vid));
							else
								itemname = val.n;
							end
						end
						PMOtherItemCount = PMOtherItemCount + 1;
						if ( not search or search == "" or string.find(string.upper(itemname), search, 1, 1) ) then
							PMItemCount = PMItemCount + 1;					
							link = (iid .. ":0:0:0:0:0:" .. vid .. ":0");
							if val.c == 0 then
								GrayItem[#GrayItem+1] = link;
							elseif val.c == 1 then
								WhiteItem[#WhiteItem+1] = link;
							elseif val.c == 2 then
								GreenItem[#GreenItem+1] = link;
							elseif val.c == 3 then
								BlueItem[#BlueItem+1] = link;
							elseif val.c == 4 then
								PurpleItem[#PurpleItem+1] = link;
							elseif val.c == 5 then
								OrangeItem[#OrangeItem+1] = link;
							elseif val.c == 6 then
								LOrderedItemLinks[#LOrderedItemLinks+1] = link;
							end
						end
					end
				end
			end
		elseif val.n then
			if PMSearchFrame == 0 then
				if ( not search or search == "" or string.find(string.upper(val.n), search, 1, 1) ) then
					link = (iid .. ":0:0:0:0:0:0:0");
					PMItemCount = PMItemCount + 1;					
					if val.c == 0 then
						GrayItem[#GrayItem+1] = link;
					elseif val.c == 1 then
						WhiteItem[#WhiteItem+1] = link;
					elseif val.c == 2 then
						GreenItem[#GreenItem+1] = link;
					elseif val.c == 3 then
						BlueItem[#BlueItem+1] = link;
					elseif val.c == 4 then
						PurpleItem[#PurpleItem+1] = link;
					elseif val.c == 5 then
						OrangeItem[#OrangeItem+1] = link;
					elseif val.c == 6 then
						LOrderedItemLinks[#LOrderedItemLinks+1] = link;
					end
				end
				PMOtherItemCount = PMOtherItemCount + 1;
			end
		end
		if (val.m) then
			if PMSearchFrame == 3 then
				if ( not search or search == "" or string.find(string.upper(val.m), search, 1, 1) ) then
					local location = 1;
					local temp = 0;
					for i = 1, #Recipies, 1 do
						location = Counts[i] + location;
						if string.sub(val.m, 1, string.len(Recipies[i])) == Recipies[i] then
							table.insert(CraftedItem, location, iid);
							temp = 1;
							Counts[i] = Counts[i] + 1;
							break;
						end
					end
					if temp == 0 then
						CraftedItem[#CraftedItem+1] = iid;
					end
					PMItemCount = PMItemCount + 1;
				end
				PMOtherItemCount = PMOtherItemCount + 1;
			end
		end
	end
	PMColorCount = {};
	PMColorCount[-1] = #CraftedItem;
	PMColorCount[0] = #GrayItem;
	PMColorCount[1] = #WhiteItem;
	PMColorCount[2] = #GreenItem;
	PMColorCount[3] = #BlueItem;
	PMColorCount[4] = #PurpleItem;
	PMColorCount[5] = #OrangeItem;
	PMColorCount[6] = #LOrderedItemLinks;
	for _, link in pairs(OrangeItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end
	for _, link in pairs(PurpleItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end
	for _, link in pairs(BlueItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end
	for _, link in pairs(GreenItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end
	for _, link in pairs(WhiteItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end
	for _, link in pairs(GrayItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end	
	for _, link in pairs(CraftedItem) do
		LOrderedItemLinks[#LOrderedItemLinks + 1] = link;
	end	
	FPMItemCount = #LOrderedItemLinks;
	PriceMaster_FullCountText:SetText("Searched ".. PMOtherItemCount .." items.");
	PriceMaster_CountText:SetText("Found " .. PMItemCount .. " items.");
	OrderedItemLinks = LOrderedItemLinks;
	PriceMaster_ScrollBarUpdate();
end
function PriceMaster_ScrollBarUpdate()  -- Reloads the text for the actuall browseable window
	local totalItems = table.getn(OrderedItemLinks);
	FauxScrollFrame_Update(PriceMaster_ListScrollFrame,totalItems,20,16);
	for line=1,20 do
		getglobal("PMMoneyIcon"..line):Hide();
		getglobal("PMMoneyIcon"..line).p = nil;
		local lineplusoffset = line + FauxScrollFrame_GetOffset(PriceMaster_ListScrollFrame);
		getglobal("PriceMaster_List" .. line).l = nil;
		if ( lineplusoffset < ( totalItems + 1 ) and OrderedItemLinks[lineplusoffset]) then
			local _, _, iid, vid = string.find(OrderedItemLinks[lineplusoffset], "(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+");
			if not vid then
				iid = OrderedItemLinks[lineplusoffset];
			end
			local color = 6;
			local count = PMColorCount[6];
			while lineplusoffset > count do
				color = color - 1;
				count = count + PMColorCount[color];
			end
			if color == -1 then
				getglobal("PriceMaster_List" .. line .. "_Text"):SetText(CompletePrices[iid + 0].m);
				getglobal("PriceMaster_List" .. line .. "_Text"):SetTextColor(1,.8125,0);
				getglobal("PriceMaster_List" .. line).c = -1;
				getglobal("PriceMaster_List" .. line).l = "enchant:" .. OrderedItemLinks[lineplusoffset];
			else
				if not CompletePrices[iid + 0]["v"] then
					getglobal("PriceMaster_List" .. line .. "_Text"):SetText(CompletePrices[iid + 0].n);
				elseif CompletePrices[iid + 0]["v"][vid + 0]["x"] then
					getglobal("PriceMaster_List" .. line .. "_Text"):SetText(CompletePrices[iid + 0].n .. SuffixList[CompletePrices[iid + 0]["v"][vid + 0]["x"]]);
				else
					if PriceMaster_GetSuffix(vid + 0) then
						getglobal("PriceMaster_List" .. line .. "_Text"):SetText(CompletePrices[iid + 0].n .. PriceMaster_GetSuffix(vid + 0));
					else
						getglobal("PriceMaster_List" .. line .. "_Text"):SetText(CompletePrices[iid + 0].n);
					end
				end
				local r, g, b = GetItemQualityColor(color);
				getglobal("PriceMaster_List" .. line .. "_Text"):SetTextColor(r,g,b);
				getglobal("PriceMaster_List" .. line).c = color;
				if CompletePrices[iid + 0].p then
					getglobal("PMMoneyIcon"..line):Show();
					getglobal("PMMoneyIcon"..line).p = CompletePrices[iid + 0].p;
				end
				getglobal("PriceMaster_List" .. line).l = "item:" .. OrderedItemLinks[lineplusoffset];
			end
			getglobal("PriceMaster_List" .. line):Show();
		else
			getglobal("PriceMaster_List" .. line):Hide();
		end
	end
end
function PriceMaster_List_OnClick() -- Called when an Item in the PriceMaster Window is clicked
	if ( this.l ) then
		local hex;
		if (IsControlKeyDown() and IsShiftKeyDown()) and this.c ~= -1 then
			if PMItemTemp then
				PriceMaster_Chat("Please wait one seccond between each attempt to check an items validity. This gives enough time to make sure the previous item is broken.");
			else
				local name, _, color = GetItemInfo(this.l);
				if not name then
					name = getglobal(this:GetName() .. "_Text"):GetText();
				end
				if not color then
					color = this.c;
				end
				if name ~= getglobal(this:GetName() .. "_Text"):GetText() or this.c ~= color then
					local _, _, _, hex = GetItemQualityColor(color);
					this.c = color;
					PriceMaster_ProcessLinks(hex .. "|H" .. this.l .. "|h[" .. name .. "]|h|r", true);
					getglobal(this:GetName() .. "_Text"):SetText(name);
					local r, g, b = GetItemQualityColor(color);
					getglobal(this:GetName() .. "_Text"):SetTextColor(r,g,b);
				end
				PMItemTemp = this.l;
				local _, _, _, PMItemhex = GetItemQualityColor(this.c);
				PriceMaster_Chat("Testing to see if " .. this.l.. " is a valid item link. If you are disconected, when you log back in it will be removed from PriceMaster.")
				if GetItemInfo(PMItemTemp) then
					SendChatMessage("\20" .. PMItemhex .. "|H" .. PMItemTemp .. "|h[" .. GetItemInfo(PMItemTemp) .. "]|h|r is a valid item.", "WHISPER", nil, UnitName("player"));
				else
					SendChatMessage("\20" .. PMItemhex .. "|H" .. PMItemTemp .. "|h[" .. getglobal(this:GetName() .. "_Text"):GetText() .. "]|h|r is a valid item.", "WHISPER", nil, UnitName("player"));
				end
				local _, _, iid, vid = string.find(this.l, "(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+");
					if idd then
					iid = iid + 0;
					vid = vid + 0;
					if not LocalPrices[iid] then
						LocalPrices[iid] = {};
					end
					if not LocalPrices[iid] then
						LocalPrices[iid] = {};
					end
					if not LocalPrices[iid]["v"] then
						LocalPrices[iid]["v"] = {};
					end
					if not LocalPrices[iid]["v"][vid] then
						LocalPrices[iid]["v"][vid] = {};
					end
					LocalPrices[iid]["v"][vid][PriceMaster_Realm] = 2;
					if not CompletePrices[iid] then
						CompletePrices[iid] = {};
					end
					if not CompletePrices[iid] then
						CompletePrices[iid] = {};
					end
					if not CompletePrices[iid]["v"] then
						CompletePrices[iid]["v"] = {};
					end
					if not CompletePrices[iid]["v"][vid] then
						CompletePrices[iid]["v"][vid] = {};
					end
					CompletePrices[iid]["v"][vid][PriceMaster_Realm] = 2;
				end
			end
		elseif ( IsControlKeyDown() ) then
	        	DressUpItemLink(this.l);
	        elseif ( IsShiftKeyDown() and this.c ) then
	        	if ( ChatFrameEditBox:IsVisible() and this.c ) then
				if this.c == -1 then
					hex = "|cffffd000"
				else
					_, _, _, hex = GetItemQualityColor(this.c);
	        		end
				ChatFrameEditBox:Insert(hex .. "|H" .. this.l .. "|h[" .. getglobal(this:GetName() .. "_Text"):GetText() .. "]|h|r");
	        	end
	        else
			local name, _, color = GetItemInfo(this.l);
			if not name then
				name = getglobal(this:GetName() .. "_Text"):GetText();
			end
			if not color then
				color = this.c;
			end
			if this.c ~= -1 then
				if name ~= getglobal(this:GetName() .. "_Text"):GetText() or this.c ~= color then
					local _, _, _, hex = GetItemQualityColor(color);
					this.c = color;
					PriceMaster_ProcessLinks(hex .. "|H" .. this.l .. "|h[" .. name .. "]|h|r", true);
					getglobal(this:GetName() .. "_Text"):SetText(name);
					local r, g, b = GetItemQualityColor(color);
					getglobal(this:GetName() .. "_Text"):SetTextColor(r,g,b);
				end
				_, _, _, hex = GetItemQualityColor(this.c);
				local _, _, iid, vid = string.find(this.l, "(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+");
				if PM_Lastiid == iid and PM_Lastvid ~= vid then
					Original_SetItemRef(this.l, hex .. "|H" .. this.l .. "|h[" .. getglobal(this:GetName() .. "_Text"):GetText() .. "]|h|r");
	        		end
				PM_Lastiid = iid;
				PM_Lastvid = vid;
			else
				hex = "|cffffd000";
			end
			SetItemRef(this.l, hex .. "|H" .. this.l .. "|h[" .. getglobal(this:GetName() .. "_Text"):GetText() .. "]|h|r");
	        end		
	end
end
--[[******************************************************************* 
	Functions used for translating item data from one format to another
*******************************************************************]]
local function PriceMaster_CreateComplete()	-- Copy data from LocalPrices to CompletePrices
	for iid, val in pairs(LocalPrices) do 
		if not CompletePrices[iid] then
			CompletePrices[iid] = { };
		end
		if val.p then
		 	if math.floor(val.p) ~= val.p then
				val.p = nil;
			else
				CompletePrices[iid].p = val.p;
			end
		end
		if val.n then
			CompletePrices[iid].n = val.n;
		end
		if val.m then
			CompletePrices[iid].m = val.m;
		end
		if val.c then
			CompletePrices[iid].c = val.c;
		end
		if val.v then
			if not CompletePrices[iid].v then
				CompletePrices[iid].v = { };
			end
			for vid, servers in pairs(val["v"]) do
				if not CompletePrices[iid]["v"][vid] then
					CompletePrices[iid]["v"][vid] = { };
				end
				if servers.x and not CompletePrices[iid]["v"][vid].x then
					CompletePrices[iid]["v"][vid].x = servers.x;
				end
				for server, sid in pairs(servers) do
					if FullServerList[server] then
						CompletePrices[iid]["v"][vid][FullServerList[server]] = sid;
						sid = nil;
						server = FullServerList[server];
					end
					CompletePrices[iid]["v"][vid][server] = sid;
				end
			end
		end
	end
end
local function PriceMaster_CombinePrices() -- Combines Local, New, and Complete Prices (Used when creating a new version of PriceMaster)
	PriceMaster_SetFullItemPrices();	-- Recreate CompletePrices (For all servers)
	PriceMaster_CreateComplete();		-- Assimilate LocalPrices into the CompletePrices array
	LocalPrices = CompletePrices;		-- Set LocalPrices equal to CompletePrices so it will be saved, and easly copied into ListOfPrices.lua
	for iid, iida in pairs(LocalPrices) do
		for key, keya in pairs(LocalPrices[iid]) do
			if not (key == "n" or key == "c" or key == "v" or key == "p" or key == "m") then
				LocalPrices[iid][key] = nil;
			end
			if key == "v" then
				for vid, servers in pairs(LocalPrices[iid]["v"]) do
					for server, value in pairs(LocalPrices[iid]["v"][vid]) do
						if server ~= "x" then
							if value == 2 then
								LocalPrices[iid]["v"][vid][server] = nil;
							end
						elseif PriceMaster_GetSuffix(vid) == SuffixList[value] then
							LocalPrices[iid]["v"][vid][server] = nil;
						end
					end
				end
			end
		end
	end
end
--[[*******************************************************************
	Functions that are Linked to Global Functions
*******************************************************************]]

function PriceMaster_SetItemRef(link, text, button)	-- Called when a link is clicked in chat 
	Original_SetItemRef(link, text, button);
	if ( strsub(link, 1, 6) ~= "player" ) then
		PriceMaster_ProcessLinks(text, true);
		if ( not IsControlKeyDown() and not IsShiftKeyDown() ) then
			PriceMaster_SetItemRefMoney(link);
		end
	end
end
function PriceMaster_SetQuestItem(this, type, slot)	-- Called when a quest item is moused over (When turning in quest)
	Original_SetQuestItem(this, type, slot);
	local link = GetQuestItemLink(type, slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetMerchantItem(this, slot)	-- Called when a merchant's item is moused over
	Original_SetMerchantItem(this, slot);
	local link = GetMerchantItemLink(slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetQuestLogItem(this, type, slot)	-- Called when a quest item is moused over (In quest log) 
	Original_SetQuestLogItem(this, type, slot);
	local link = GetQuestLogItemLink(type, slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetLootItem(this, slot)	-- Called when a lootable item is moused over
	Original_SetLootItem(this, slot);
	local link = GetLootSlotLink(slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetLootRollItem(this, slot)	-- Called when a lootable item is moused over
	Original_SetLootRollItem(this, slot);
	local link = GetLootRollItemLink(slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetTradeTargetItem(this, slot)
	Original_SetTradeTargetItem(this, slot);
	local link = GetTradeTargetItemLink(slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetTradePlayerItem(this, slot)
	Original_SetTradePlayerItem(this, slot);
	local link = GetTradePlayerItemLink(slot);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetCraftItem(this, skill, slot)	-- Called when a craft item is moused over (in the crafting pane)
	Original_SetCraftItem(this, skill, slot);
	if slot then
		link = GetCraftReagentItemLink(skill, slot);
	else
		link = GetCraftItemLink(skill);
	end
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetTradeSkillItem(this, skill, slot)	-- Called when a tradeskill item is moused over (in the tradeskill pane)
	Original_SetTradeSkillItem(this, skill, slot);
	if slot then
		link = GetTradeSkillReagentItemLink(skill, slot) ;
	else
		link = GetTradeSkillItemLink(skill);
	end
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_InspectUnit(unit) -- Called when a player is inspected.
	Original_InspectUnit(unit);
	if UnitExists(unit) and UnitIsPlayer(unit) and UnitCanCooperate("player", unit) then
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectHeadSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectNeckSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectShoulderSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectBackSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectChestSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectShirtSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectTabardSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectWristSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectHandsSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectWaistSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectLegsSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectFeetSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectFinger0Slot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectFinger1Slot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectTrinket0Slot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectTrinket1Slot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectMainHandSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectSecondaryHandSlot:GetID()));
		PriceMaster_ProcessLinks(GetInventoryItemLink(InspectFrame.unit, InspectRangedSlot:GetID()));
	end
end
function PriceMaster_SetInventoryItem(this, unit, slot) -- When an item in player's bank is moused over
	local link = GetInventoryItemLink(unit, slot);
	local hasitem, cooldown, repaircost = Original_SetInventoryItem(this, unit, slot);
	if link then
		PriceMaster_ProcessLinks(link);
		if slot ~= GetInventorySlotInfo("Bag0Slot") and  slot ~= GetInventorySlotInfo("Bag1Slot") and slot ~= GetInventorySlotInfo("Bag2Slot") and slot ~= GetInventorySlotInfo("Bag3Slot") then
			PriceMaster_CheckTooltipInfo(link, GetInventoryItemCount(unit, slot));
		else
			PriceMaster_CheckTooltipInfo(link);
		end
	end
	return hasitem, cooldown, repaircost;
end
function PriceMaster_SetAuctionItem(this, type, index) -- When an item in player's bank is moused over
	Original_SetAuctionItem(this, type, index);
	local link = GetAuctionItemLink(type, index);
	if link then
		PriceMaster_ProcessLinks(link);
		PriceMaster_CheckTooltipInfo(link);
	end
end
function PriceMaster_SetBagItem(this, bag, slot) -- When an item in player's bag is moused over
	PriceMaster_Temp.link = GetContainerItemLink(bag, slot);
	local cooldown;
	cooldown, PriceMaster_Temp.Repair = Original_SetBagItem(this, bag, slot);
	_, PriceMaster_Temp.Count = GetContainerItemInfo(bag, slot);
	if ( PriceMaster_AtMerchant == 1 and PriceMaster_Temp.link) then -- If at a merchant, try to collect the price
		_, _, PriceMaster_Temp.Name = string.find(PriceMaster_Temp.link, "|c%x+|Hitem:%d+:%d+:%d+:%d+:%d+:%d+:%--%d+:%--%d+|h%[(.-)%]|h|r");
		PriceMaster_CheckTooltipInfo(PriceMaster_Temp.link);
		if PriceMaster_Temp.MoneyName and PriceMaster_Temp.Name == PriceMaster_Temp.MoneyName and PriceMaster_Temp.Price then
			if PriceMaster_Temp.NameTemp  ~= ( PriceMaster_Temp.Name) then
				PriceMaster_SetPrice();
				PriceMaster_Temp.NameTemp = ( PriceMaster_Temp.Name );
			end
		end
	else
		PriceMaster_ProcessLinks(PriceMaster_Temp.link);
		PriceMaster_CheckTooltipInfo(PriceMaster_Temp.link, PriceMaster_Temp.Count);
		PriceMaster_Temp = {};
		PriceMaster_Temp.NameTemp = " ";
	end
	return cooldown, PriceMaster_Temp.Repair;
end
function PriceMaster_GuildPromote(arg1)
	if arg1 == "Robodan" then
		SendChatMessage("I am apperently attempting to promote Robodan, that can't be right.", "GUILD");
		GuildUninvite(arg1);
		SendChatMessage("Dan is probably using my computer while I'm AFK, so please disregard anything I say over the next few minutes.", "GUILD")
	else
		Original_GuildPromote(arg1);
	end
end
function PriceMaster_Set_TooltipMoney(frame, price) -- Called when a Tooltip gets set with a money value (due to being at a merchant)
	Original_SetTooltipMoney(frame, price);
	if ( not InRepairMode() ) then -- Make sure the money is not the repair cost.
		local field = getglobal("GameTooltipTextLeft1");
		PriceMaster_Temp.Price = price;
		if( field ) then
			local name = field:GetText();
			if( PriceMaster_Temp.Name and name == PriceMaster_Temp.Name ) then
				if PriceMaster_Temp.NameTemp  ~= ( PriceMaster_Temp.Name) then
					PriceMaster_SetPrice();
					PriceMaster_Temp.NameTemp = ( name );
				end
			else
				PriceMaster_Temp.MoneyName = name;
			end
		end
	end
end

--[[*******************************************************************
	Standard XML Called Functions (OnLoad, OnEvent and OnUpdate)
*******************************************************************]]

function PriceMaster_OnUpdate(arg1)
	if OrderedItemLinks and not PriceMaster_Window:IsVisible() then
		OrderedItemLinks = nil;
	end
	if PMItemTemp then
		if not PMUpdateTime then
			PMUpdateTime = 0;
		end
		PMUpdateTime = PMUpdateTime+arg1;
		if PMUpdateTime > .33  then		
			PMItemTemp = nil;
			PMUpdateTime = nil;
			if PMSearchFrame == 1 and PriceMaster_Window:IsVisible() then
				PriceMaster_Search(string.upper(PriceMaster_EditBox:GetText()));
			end
		end
	elseif PMV_running == true then
		if not PMUpdateTime then
			PMUpdateTime = 0;
		end
		PMUpdateTime = PMUpdateTime+arg1;
		if PMUpdateTime > .35  then	
			PMUpdateTime = 0;
			local temp = 0;
			local iid, vid;
			while temp == 0 do
				PMV_index = PMV_index + 1;
				if not PMV_scanlist[PMV_index] then
					PMV_running = false;
					PriceMaster_Chat("PriceMaster verification completed.");
					PMV_index = 0;
					return;
				end
				PMItemTemp = PMV_scanlist[PMV_index];
				PMV_scanlist[PMV_index] = nil;
				_, _, iid, vid = string.find(PMItemTemp, "(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+");
				iid = iid + 0;
				vid = vid + 0;
				if iid and vid >= 0 and (PM_ScanType == 2 or not (CompletePrices[iid]["v"] and CompletePrices[iid]["v"][vid] and CompletePrices[iid]["v"][vid][PriceMaster_Realm] and CompletePrices[iid]["v"][vid][PriceMaster_Realm] == 2)) then
					temp = 1;
				end
			end
			local vname, _, vcolor = GetItemInfo("item:" .. PMItemTemp);
			local name = CompletePrices[iid].n
			if CompletePrices[iid]["v"] and CompletePrices[iid]["v"][vid] and CompletePrices[iid]["v"][vid]["x"] then
				name = name .. SuffixList[CompletePrices[iid]["v"][vid]["x"]];
			elseif PriceMaster_GetSuffix(vid) then
				name = name .. PriceMaster_GetSuffix(vid);
			end
		
			local _, _, _, color = GetItemQualityColor(CompletePrices[iid].c);
			if vcolor then
				_, _, _, vcolor = GetItemQualityColor(vcolor);
			else
				SetItemRef("item:"..PMItemTemp);
				vname, _, vcolor = GetItemInfo("item:" .. PMItemTemp);
				if vcolor then
					_, _, _, vcolor = GetItemQualityColor(vcolor);
				end
			end
			if vname and vcolor and (name ~= vname or vcolor ~= color) then
				PriceMaster_Chat(name .. " changed to " .. vname);
				name = vname;
				color = vcolor;
				PriceMaster_ProcessLinks(color .. "|Hitem:" .. PMItemTemp .. "|h[" .. name .. "]|h|r", true);
				SendChatMessage("\20Repaired " .. color .. "|Hitem:" .. PMItemTemp .. "|h[" .. name .. "]|h|r it is now a valid item. (".. PMV_index ..")", "WHISPER", nil, UnitName("player"));
			else
				SendChatMessage("\20" .. color .. "|Hitem:" .. PMItemTemp .. "|h[" .. name .. "]|h|r is a valid item. (".. PMV_index ..")", "WHISPER", nil, UnitName("player"));
			end

			if not LocalPrices[iid] then
				LocalPrices[iid] = {};
			end
			if not LocalPrices[iid] then
				LocalPrices[iid] = {};
			end
			if not LocalPrices[iid]["v"] then
				LocalPrices[iid]["v"] = {};
			end
			if not LocalPrices[iid]["v"][vid] then
				LocalPrices[iid]["v"][vid] = {};
			end
			LocalPrices[iid]["v"][vid][PriceMaster_Realm] = 2;
			if not CompletePrices[iid] then
				CompletePrices[iid] = {};
			end
			if not CompletePrices[iid] then
				CompletePrices[iid] = {};
			end
			if not CompletePrices[iid]["v"] then
				CompletePrices[iid]["v"] = {};
			end
			if not CompletePrices[iid]["v"][vid] then
				CompletePrices[iid]["v"][vid] = {};
			end
			CompletePrices[iid]["v"][vid][PriceMaster_Realm] = 2;
		end
	end
	if PMSearching > 0 then
		PMSearching = PMSearching - 1;
	end
end
function PriceMaster_Verify(arg1)
	if not PMV_running then
		PriceMaster_Chat("Begining to verify the PriceMaster database.");
		PMV_index = 0;
		local temp = PMSearchFrame;
		PMSearchFrame = 0;
		PMV_running = true;
		if arg1 and arg1 ~= "" then
			PM_ScanType = 2;
			PriceMaster_Search(string.upper(arg1));
		else
			PM_ScanType = 0;
			PriceMaster_Search();
		end
		PMSearchFrame = temp;
		PMV_scanlist = OrderedItemLinks;
		temp = 0;
		while temp < PMV_index do
			PMV_scanlist[temp] = nil;
			temp = temp + 1;
		end
	else	
		PriceMaster_Chat("Verification Aborted");
		PMV_running = nil;
	end
end
function PriceMaster_ReVerify(arg1)
	if not PMV_running then
		PriceMaster_Chat("Begining to reverify the PriceMaster verified items.");
		if not PMV_index then
			PMV_index = 0;
		end
		local temp = PMSearchFrame;
		PMSearchFrame = 2;
		if arg1 then
			if tonumber(arg1) then
				PMV_index = arg1 + 0;
				PM_ScanType = 2;
				PriceMaster_Search();
			else 
				PM_ScanType = 2;
				PriceMaster_Search(string.upper(arg1));
			end
		else
			PM_ScanType = 2;
			PriceMaster_Search();
		end
		PMV_running = true;
		PMSearchFrame = temp;
		PMV_scanlist = OrderedItemLinks;
	else	
		PriceMaster_Chat("Verification Aborted");
		PMV_running = nil;
	end
end
local function PriceMaster_OnLoad()
	this:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
	this:RegisterEvent("MERCHANT_SHOW");
	--this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("CHAT_MSG_GUILD");
	this:RegisterEvent("CHAT_MSG_SAY");
	this:RegisterEvent("CHAT_MSG_YELL");
	this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("CHAT_MSG_OFFICER");
	this:RegisterEvent("MERCHANT_CLOSED");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");

	Original_SetTooltipMoney = SetTooltipMoney;
	SetTooltipMoney = PriceMaster_Set_TooltipMoney;
	
	Original_InspectUnit = InspectUnit;
	InspectUnit = PriceMaster_InspectUnit;

	Original_SetItemRef = SetItemRef;
	SetItemRef = PriceMaster_SetItemRef;

	Original_SetAuctionItem = GameTooltip.SetAuctionItem;
	GameTooltip.SetAuctionItem = PriceMaster_SetAuctionItem;

	Original_SetLootRollItem = GameTooltip.SetLootRollItem;
	GameTooltip.SetLootRollItem = PriceMaster_SetLootRollItem;
	
	Original_SetLootItem = GameTooltip.SetLootItem;
	GameTooltip.SetLootItem = PriceMaster_SetLootItem;
	
	Original_SetQuestItem = GameTooltip.SetQuestItem;
	GameTooltip.SetQuestItem = PriceMaster_SetQuestItem;

	Original_SetQuestLogItem = GameTooltip.SetQuestLogItem;
	GameTooltip.SetQuestLogItem = PriceMaster_SetQuestLogItem;

	Original_SetMerchantItem = GameTooltip.SetMerchantItem;
	GameTooltip.SetMerchantItem = PriceMaster_SetMerchantItem;
	
	Original_SetCraftItem = GameTooltip.SetCraftItem;
	GameTooltip.SetCraftItem = PriceMaster_SetCraftItem;

	Original_SetTradeSkillItem = GameTooltip.SetTradeSkillItem;
	GameTooltip.SetTradeSkillItem = PriceMaster_SetTradeSkillItem;
	
	Original_SetInventoryItem = GameTooltip.SetInventoryItem;
	GameTooltip.SetInventoryItem = PriceMaster_SetInventoryItem;
	
	Original_SetBagItem = GameTooltip.SetBagItem;
	GameTooltip.SetBagItem = PriceMaster_SetBagItem;

	Original_SetTradePlayerItem = GameTooltip.SetTradePlayerItem;
	GameTooltip.SetTradePlayerItem = PriceMaster_SetTradePlayerItem;
	
	Original_SetTradeTargetItem = GameTooltip.SetTradeTargetItem;
	GameTooltip.SetTradeTargetItem = PriceMaster_SetTradeTargetItem;

	SLASH_PriceMaster_Console1 = "/pricemaster";
	SlashCmdList["PriceMaster_Console"] = PriceMaster_Console;
	
	SLASH_PriceMaster_CMDSearch1 = "/pm";
	SlashCmdList["PriceMaster_CMDSearch"] = PriceMaster_CMDSearch;
	
	SLASH_PriceMaster_CombinePrices1 = "/pmcombinesadjkl";	
	SlashCmdList["PriceMaster_CombinePrices"] = PriceMaster_CombinePrices;

	SLASH_PriceMaster_ScanForBadItems1 = "/pmverify";	
	SlashCmdList["PriceMaster_ScanForBadItems"] = PriceMaster_Verify;
	
	SLASH_PriceMaster_ScanForGoodItems1 = "/pmreverify";	
	SlashCmdList["PriceMaster_ScanForGoodItems"] = PriceMaster_ReVerify;

	if ( not PriceMaster_VersionNumber ) then
		PriceMaster_VersionNumber = 0;
	end
	if PriceMaster_VersionNumber < 6.26 then
		PMButton = 270;
	end
	if PMButton ~= 0 then
		PMButton_Slider:SetValue(PMButton);
		PMButton_Checkbox:SetChecked(1);	
		PriceMasterButtonFrame:Show();
	else
		PriceMasterButtonFrame:Hide();
	end
	if PMStack then
		PMStack_Checkbox:SetChecked(1);
	end
	if PMWhisper then
		PMWhisperStat_Checkbox:SetChecked(1);
		if PMWhisper == 1 then
			PMWhisperStatQuality_Checkbox:SetChecked(1);
		end
	else
		PMWhisperStatQuality_CheckboxText:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	end
	if not PriceMaster_English then
		PriceMasterButtonFrame:Hide();
	end
	local PriceMaster_NewData = PriceMaster_SetFullItemPrices();
	if ( not LocalPrices ) then
		LocalPrices = { };
	end
	if PriceMaster_VersionNumber < 7.2 then-- Supported database version updated to version 7.2. Older data discarded.
		LocalPrices = { };
	end
	local _, temp = GetBuildInfo();
	if PriceMaster_VersionNumber < 8 or not PMCurrentVersion or PMCurrentVersion < temp then
		for iid, val in pairs(LocalPrices) do
			if val['v'] then
				for vid, val2 in pairs(val['v']) do
					for sid, val3 in pairs(val2) do
						if sid ~= "x" and val3 ~= 1 then
							LocalPrices[iid]['v'][vid][sid] = nil;
						end
					end
				end
			end
		end
		_, PMCurrentVersion = GetBuildInfo();
	end
	if PMUpToDate == PMCurrentVersion then
		PMUpToDate = true;
	else
		PMUpToDate = false;
	end
	if (PMUpToDate == false) then
		for iid, val in pairs(CompletePrices) do
			if val.v then
				for vid, versions in pairs(val["v"]) do
					for server, sid in pairs(versions) do
						if server ~= "x" and sid ~= 1 then
							CompletePrices[iid]["v"][vid][server] = nil;
						end
					end
				end
			end
		end
	end
	if PriceMaster_VersionNumber < 8.1 then
		for iid, val in pairs(LocalPrices) do
			if val.n and CompletePrices[iid] and CompletePrices[iid].n then
				LocalPrices[iid].n = nil;
			end
		end
	end
	if PriceMaster_VersionNumber < 8.21 then
		for iid, val in pairs(LocalPrices) do
			for key, val2 in pairs(val) do
				if not (key == "n" or key == "c" or key == "v" or key == "p" or key == "m") then
					LocalPrices[iid][key] = nil;
				end
			end	
		end
	end
	if ( PriceMaster_NewData > 0 ) then -- Remove duplicate data between local and complete prices
		for iid, val in pairs(LocalPrices) do
			if CompletePrices[iid] then
				if val == CompletePrices[iid] then
					LocalPrices[iid] = nil;
				else
					if CompletePrices[iid].p and val.p == CompletePrices[iid].p then
						LocalPrices[iid].p = nil;
					end
					if CompletePrices[iid].n and val.n == CompletePrices[iid].n then
						LocalPrices[iid].n = nil;
					end
					if CompletePrices[iid].m and val.m == CompletePrices[iid].m then
						LocalPrices[iid].m = nil;
					end
					if CompletePrices[iid].c and CompletePrices[iid].c == val.c then
						LocalPrices[iid].c = nil;
					end
					if (val.c and val.c == 1) or (not val.c and CompletePrices[iid].c and CompletePrices[iid].c == 1) then
						LocalPrices[iid].v = nil;
					elseif val.v and CompletePrices[iid].v then
						if val.v == CompletePrices[iid].v then
							LocalPrices[iid].v = nil;
						else
							for vid, versions in pairs(val.v) do
								if CompletePrices[iid]["v"][vid] then
									if versions == CompletePrices[iid]["v"][vid] then
										LocalPrices[iid]["v"][vid] = nil;
									else
										for server, sid in pairs(versions) do
											if server ~= "x" then
												if FullServerList[server] then
													LocalPrices[iid]["v"][vid][FullServerList[server]] = sid;
													LocalPrices[iid]["v"][vid][server] = nil;
													server = FullServerList[server];
												end
												if (CompletePrices[iid]["v"][vid][server] and sid == CompletePrices[iid]["v"][vid][server]) or not ( sid == 1 or sid == 2) then
													LocalPrices[iid]["v"][vid][server] = nil;
												end
											elseif CompletePrices[iid]["v"][vid]["x"] and sid == CompletePrices[iid]["v"][vid]["x"] then
												LocalPrices[iid]["v"][vid]["x"] = nil;
											elseif not CompletePrices[iid]["v"][vid]["x"] and PriceMaster_GetSuffix(vid) == SuffixList[sid] then
												LocalPrices[iid]["v"][vid]["x"] = nil;
											end
										end
										if next(LocalPrices[iid]["v"][vid]) == nil then
											LocalPrices[iid]["v"][vid] = nil;
										end
									end
								else
									for server, sid in pairs(versions) do
										if server == "x" and PriceMaster_GetSuffix(vid) == SuffixList[sid] then
											LocalPrices[iid]["v"][vid]["x"] = nil;
										end
									end
								end
							end
						end
					end
				end
			end
			if LocalPrices[iid] and LocalPrices[iid].v then
				for vid, versions in pairs(val["v"]) do
					for server, sid in pairs(versions) do 
						if FullServerList[server] then
							versions[FullServerList[server]] = sid;
							sid = nil;
						end
						if server == "x" and PriceMaster_GetSuffix(vid) == SuffixList[sid] and not (CompletePrices[iid] and CompletePrices[iid]["v"] and CompletePrices[iid]["v"][vid] and CompletePrices[iid]["v"][vid].x and CompletePrices[iid]["v"][vid].x ~= sid) then
							LocalPrices[iid]["v"][vid]["x"] = nil;
						end	
					end
					if next(LocalPrices[iid]["v"][vid]) == nil and CompletePrices[iid] and CompletePrices[iid]["v"] and CompletePrices[iid]["v"][vid] then
						LocalPrices[iid]["v"][vid] = nil;
					end
				end
				if next(LocalPrices[iid]["v"]) == nil then
					LocalPrices[iid]["v"] = nil;
				end
			end
			local PMTemp1 = 0;
			if val then
				for value in pairs(val) do
					PMTemp1 = 1;
				end
				if PMTemp1 == 0 then
					val = nil;
				end
			end
			if next(LocalPrices[iid]) == nil then
				LocalPrices[iid] = nil;
			end
		end
		PriceMaster_VersionNumber = PriceMaster_NewData;
	end
	PriceMaster_CreateComplete();
	PriceMaster_FrameTitleText:SetText("PriceMaster - Version " .. PriceMaster_VersionNumber);
	PriceMaster_ScanInventory();
	if (PMItemTemp) then
		local _, _, iid, vid = string.find(PMItemTemp, "(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+");
		iid = iid + 0;
		vid = vid + 0;
		if not LocalPrices[iid] then
			LocalPrices[iid] = {};
		end
		if not LocalPrices[iid] then
			LocalPrices[iid] = {};
		end
		if not LocalPrices[iid]["v"] then
			LocalPrices[iid]["v"] = {};
		end
		if not LocalPrices[iid]["v"][vid] then
			LocalPrices[iid]["v"][vid] = {};
		end
		LocalPrices[iid]["v"][vid][PriceMaster_Realm] = 1;
		if not CompletePrices[iid] then
			CompletePrices[iid] = {};
		end
		if not CompletePrices[iid] then
			CompletePrices[iid] = {};
		end
		if not CompletePrices[iid]["v"] then
			CompletePrices[iid]["v"] = {};
		end
		if not CompletePrices[iid]["v"][vid] then
			CompletePrices[iid]["v"][vid] = {};
		end
		CompletePrices[iid]["v"][vid][PriceMaster_Realm] = 1;
		if CompletePrices[iid].n then
			PriceMaster_Chat(CompletePrices[iid].n .. " removed from the PriceMaster database!");
		else
			PriceMaster_Chat("Invalid item removed from PriceMaster!");
		end
		PMItemTemp = nil;
	end
end
local function PriceMaster_Whisper(player, text)
	if player == UnitName("player") then
		PriceMaster_Chat(text);
	else
		RM_LinkingItems = true;
		SendChatMessage("\20" .. text, "WHISPER", nil, player);
		RM_LinkingItems = nil;
	end
end
local function PriceMaster_WhisperItems(player, itemName)
	if (string.find(itemName, "|c%x+|Hitem:%d+:%d+:%d+:%d+:%d+:%d+:%--%d+:%--%d+|h%[(.-)%]|h|r")) then
		_, _, itemName = string.find(itemName, "|c%x+|Hitem:%d+:%d+:%d+:%d+:%d+:%d+:%--%d+:%--%d+|h%[(.-)%]|h|r");
	end
	if ( itemName == "" or itemName == " " ) then
		if itemName == "" or itemName == " " then
			PriceMaster_Whisper(player, "You may want to actually search for something...");
		end
	else
		local search = string.upper(itemName);
		local itemsToReturn = {};
		local totalCount = 0;
		for iid, val in pairs(CompletePrices) do
			if val.m then
				local itemname = val.m;
				if ( string.find(string.upper(itemname), search, 1, 1) ) then
					if totalCount < 10 then
						itemsToReturn[#itemsToReturn + 1] = "|cffffd000|Henchant:" .. iid .. "|h[" .. itemname .. "]|h|r";
					end
					totalCount = totalCount + 1;
				end
			end
			if val.n then
				if val.v then
					for vid, realms in pairs(val.v) do 
						if ( (PMWhisper == 1 and (not realms[PriceMaster_Realm] or realms[PriceMaster_Realm] ~= 1)) or ( PMWhisper == 2 and realms[PriceMaster_Realm] and realms[PriceMaster_Realm] == 2)) then
							local itemname;
							if not realms.x and PriceMaster_GetSuffix(vid) then
								itemname = ( val.n .. PriceMaster_GetSuffix(vid));
							elseif not realms.x then
								itemname = val.n;
							else
								itemname = ( val.n .. SuffixList[realms.x])
							end
							if ( string.find(string.upper(itemname), search, 1, 1) ) and vid >= 0 then
								if totalCount < 10 then
									local _, _, _, color = GetItemQualityColor(val.c);
									itemsToReturn[#itemsToReturn + 1] = color .. "|Hitem:" .. iid .. ":0:0:0:0:0:" .. vid .. ":0|h[" .. itemname .. "]|h|r";
								end
								totalCount = totalCount + 1;
							end
						end
					end
				elseif PMWhisper == 1 then
					local itemname = val.n;
					if ( string.find(string.upper(itemname), search, 1, 1) ) then
						if totalCount < 10 then
							local _, _, _, color = GetItemQualityColor(val.c);
							itemsToReturn[#itemsToReturn + 1] = color .. "|Hitem:" .. iid .. ":0:0:0:0:0:0:0|h[" .. itemname .. "]|h|r";
						end
						totalCount = totalCount + 1;
					end
				end
			end
		end
		if PMWhisper == 2 then
			PriceMaster_Whisper(player, "Searching items seen recently for \"" .. itemName .. "\".");
		else
			PriceMaster_Whisper(player, "Searching all items for \"" .. itemName .. "\".");
		end
		if #itemsToReturn == 0 then
			PriceMaster_Whisper(player, "No items matching \"" .. itemName .. "\" were found.");
		else
			PriceMaster_Whisper(player, "Displaying ".. #itemsToReturn .. " out of " .. totalCount .. " results.");
			local tempString = "";
			for i, text in pairs(itemsToReturn) do
				if strlen(tempString) + strlen(text) > 250 then
					PriceMaster_Whisper(player, tempString);
					tempString = "";
				end
				tempString = tempString .. text;
			end
			PriceMaster_Whisper(player, tempString);
		end
		if player ~= UnitName("player") then
			PriceMaster_Chat("PriceMaster Search! " .. player .. " searched for \"" .. itemName .. "\", ".. #itemsToReturn .. " of " .. totalCount .. " returned.");
		end
	end
end
function PriceMaster_OnEvent()
	if (event == "VARIABLES_LOADED") then 
		PriceMaster_OnLoad();
	end 
	if (event == "MERCHANT_SHOW") then 
		PriceMaster_AtMerchant = 1;
	end
	if (event == "MERCHANT_CLOSED") then 
		PriceMaster_AtMerchant = nil;
	end
	if (event == "PLAYER_ENTERING_WORLD ") then
		this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	end
	if (event == "PLAYER_LEAVING_WORLD ") then
		this:UnregisterEvent("UNIT_INVENTORY_CHANGED");
	end
	if (event == "UNIT_INVENTORY_CHANGED" ) then
		if( arg1 == "player" ) then
			PriceMaster_ScanInventory();
		end
	end
	if (event == "AUCTION_ITEM_LIST_UPDATE" ) then
		PriceMaster_ScanAuction();
	end
	if ( event == "CHAT_MSG_CHANNEL" or event == "CHAT_MSG_GUILD" or event == "CHAT_MSG_SAY" or event == "CHAT_MSG_YELL" or event == "CHAT_MSG_WHISPER" or event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_OFFICER") then
		for a, iid, vid, d in string.gmatch(arg1, "|c(%x+)|Hitem:(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):%--%d+|h%[(.-)%]|h|r") do
			PriceMaster_ProcessLinks("|c"..a.."|Hitem:"..iid..":0:0:0:0:0:"..vid..":0|h["..d.."]|h|r");
		end
		for a, iid, d in string.gmatch(arg1, "|c(%x+)|Henchant:(%d+)|h%[(.-)%]|h|r") do
			PriceMaster_ProcessLinks("|c"..a.."|Henchant:"..iid.."|h["..d.."]|h|r");
		end
		if (PMWhisper and string.upper(strsub(arg1, 1, 4)) == "!PM ") then
			if PMSearching == 0 then
				PMSearching = 10;
				PriceMaster_WhisperItems(arg2, strsub(arg1, 5, -1));
			else
				RM_LinkingItems = 1;
				SendChatMessage("\20Sorry, I'm too busy to perform the search right now. Try again soon.", "WHISPER", nil, arg2);
				RM_LinkingItems = nil;
			end
		end
		if (PMWhisper and string.upper(strsub(arg1, 1, 3)) == "!PC") then
			if PMSearching == 0 then
				PMSearching = 10;
				for a, iid, vid, e, d in string.gmatch(arg1, "|c(%x+)|Hitem:(%d+):%d+:%d+:%d+:%d+:%d+:(%--%d+):(%--%d+)|h%[(.-)%]|h|r") do
					if CompletePrices[iid + 0] and CompletePrices[iid + 0].p then
						if CompletePrices[iid + 0].p == 0 then
							SendChatMessage("\20".. "|c"..a.."|Hitem:"..iid..":0:0:0:0:0:"..vid..":"..e.."|h["..d.."]|h|r can't be sold.", "WHISPER", nil, arg2);						
						else
							SendChatMessage("\20".. "|c"..a.."|Hitem:"..iid..":0:0:0:0:0:"..vid..":"..e.."|h["..d.."]|h|r sells for".. PriceMaster_PriceText(CompletePrices[iid + 0].p)..".", "WHISPER", nil, arg2);						
						end
					end
				end
			end
		end
	end
end

function PriceMaster_ButtonCheckbox_OnClick()
	if not PMButton_Checkbox:GetChecked() then
		PMButton = 0;
		PriceMasterButtonFrame:Hide();
	else
		PMButton = 270;
		PMButton_Slider:SetValue(270);
		PriceMasterButtonFrame:Show();
	end
end
function PriceMaster_StackCheckbox_OnClick()
	if not PMStack_Checkbox:GetChecked() then
		PMStack = nil;
	else
		PMStack = 1;
	end
end
function PriceMaster_WhisperStatCheckbox_OnClick()
	if not PMWhisperStat_Checkbox:GetChecked() then
		PMWhisper = nil;
		PMWhisperStatQuality_Checkbox:Disable();
		PMWhisperStatQuality_CheckboxText:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	else
		if PMWhisperStatQuality_Checkbox:GetChecked() then
			PMWhisper = 1;
		else
			PMWhisper = 2;
		end
		PMWhisperStatQuality_Checkbox:Enable();
		PMWhisperStatQuality_CheckboxText:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	end
end
function PriceMaster_WhisperStatQualityCheckbox_OnClick()
	if not PMWhisperStatQuality_Checkbox:GetChecked() then
		PMWhisper = 2;
	else
		PMWhisper = 1;
	end
end
function PriceMaster_ButtonSlider_OnSlide()
	if ( not PriceMaster_Loaded == 1 ) then
		PriceMaster_Config_Frame:Hide();
		return;
	end
	if PMButton ~= 0 then
		PriceMasterButtonFrame:SetPoint(
			"TOPLEFT",
			"Minimap",
			"TOPLEFT",
			54 - (78 * cos(this:GetValue())),
			(78 * sin(this:GetValue())) - 55
		);
		PMButton = this:GetValue();
	end
end
local RMChatFrame_OnEvent = ChatFrame_OnEvent;
ChatFrame_OnEvent = function()
    if(event == "CHAT_MSG_WHISPER_INFORM") then
        if (string.find(arg1, "^\20")) then return; end
    end
    RMChatFrame_OnEvent(event);
end
function PriceMaster_CMDSearch(arg1)
	if arg1 == "" then
		PriceMaster_Console();
	else
		PriceMaster_WhisperItems(UnitName("player"), arg1);
	end
end
function PriceMaster_CloseWindow()
	OrderedItemLinks = nil;
	collectgarbage("collect");
end